/********************************************************************
	DOT MATRIX CLOCK Ver 1.0

	P@[Jϐɂ͐iTCYHj̐炵
	Q@rbgVtg̓O[oϐōsׂ
	R@ݒɃf[^j󂳂\iHj
	S@f[^ҏWɂ͊荞݂̃R[𐧌ׂ
	T@LjƋςɂȂ邱Ƃ

	PORTA 0,1,2 = 74HC138 ւ̐M(138̓J\[hɐڑj
		  3,4,5 = {^
		  7,8   = NbN
	PORTB 0-7   = }gbNXLED̃Am[h
*********************************************************************/
#include <htc.h>
#define _XTAL_FREQ 11776000
__CONFIG(UNPROTECT & LVPDIS & BORDIS & MCLRDIS & PWRTEN & WDTDIS & HS);

//#define SEC_COUNT	250000			// 4MHZ̏ꍇ1b
#define SEC_COUNT	736000			// 11.776MHz̏ꍇ1b
#define CHR_WIDTH_L	8				// TCY@L=8DOT
#define CHR_WIDTH_M	6				// @@@@@@@@M=6DOT
#define CHR_WIDTH_S	4				// @@@@@@@@S=4DOT
#define CHR_SFT_L	0				// lߕ LS
#define CHR_SFT_M	2				// @@@@@M
#define CHR_SFT_S	4				// @@@@@S
#define MAX_ROW		8				// ső
#define EEP_BLOCK	8				// EEPROM̃ubNTCY
#define MODE_CLOCK	0				// [hENbN
#define MODE_SECOND	1				// @@@@b
#define MODE_ADJHH	2				// @@@@Zbg
#define MODE_ADJMM	3				// @@@@Zbg
#define MODE_SLEEP	4				// @@@@X[v
#define SWT_MODE	RA3				// SWITCH MODE
#define SWT_1		RA4				// SWITCH 1
#define SWT_2		RA5				// SWITCH 2
#define DSP_COL		10				// R
#define DSP_AM		11				// AM
#define DSP_PM		12				// PM
#define DSP_BLK		13				// uN
#define SMALL_0		14				// O
#define DSP_ADJHH	24				// 
#define DSP_ADJMM	25				// 
#define DSP_SLEEP	26				// SLEEP
#define	WATCH_SLP	360				// SLEEP

static long t_save;
unsigned char dgt[10], hh, mm, ss, button_mode, slp_mode, slp_on, adj_on;
unsigned char disp_len, disp_ch, disp_bt, disp_next, chr_width, chr_sft;
unsigned char rom_dat[MAX_ROW];
unsigned char make_dot_doing, make_st_doing, ee_dat, ee_adr;
unsigned short dat_up, dat_dn, watch;

void make_string() {									// 쐬
	char ch_size;

	make_st_doing = 1;
	switch (button_mode) {
		case MODE_CLOCK:								// \[h̎
			if (hh < 13) {								// AM
				dgt[0] = DSP_AM;
				dgt[1] = hh / 10;
				dgt[2] = hh % 10;
			} else {									// PM
				dgt[0] = DSP_PM;
				dgt[1] = (hh - 12) / 10;
				dgt[2] = (hh - 12) % 10;
			}
			dgt[3] = DSP_COL;
			dgt[4] = mm / 10;
			dgt[5] = mm % 10;
			dgt[6] = DSP_BLK;
			disp_len = 6;								// 񕝐=6
			chr_width = CHR_WIDTH_M;					// ꕶ̃hbg
			chr_sft = CHR_SFT_M;						// l
			ch_size = 'M';								// 
			break;
		case MODE_SECOND:								// b[h̎
			dgt[0] = ss / 10 + SMALL_0;
			dgt[1] = ss % 10 + SMALL_0;
			ch_size = 'S';
			break;
		case MODE_ADJHH:								// Zbg̎
			if (adj_on) {
				dgt[0] = hh / 10 + SMALL_0;
				dgt[1] = hh % 10 + SMALL_0;
				ch_size = 'S';
			} else {
				dgt[0] = DSP_ADJHH;
				ch_size = 'L';
		}
			break;
		case MODE_ADJMM:								// Zbg̎
			if (adj_on) {
				dgt[0] = mm / 10 + SMALL_0;
				dgt[1] = mm % 10 + SMALL_0;
				ch_size = 'S';
			} else {
				dgt[0] = DSP_ADJMM;
				ch_size = 'L';
			}
			break;
		case MODE_SLEEP:								// X[v[h̎
			dgt[0] = DSP_SLEEP + slp_mode;
			ch_size = 'L';
			break;
	}
	switch (ch_size) {									// (M)ȊO
		case 'S':										// 
			disp_ch = 0;								// 1ڃCfbNX
			disp_bt = 0;								// XN[Ehbg
			disp_len = 1;								// 
			chr_width = CHR_WIDTH_S;
			chr_sft = CHR_SFT_S;
			break;
		case 'L':
			disp_ch = 0;
			disp_bt = 0;
			disp_len = 0;
			chr_width = CHR_WIDTH_L;
			chr_sft = CHR_SFT_L;
	}
	make_st_doing = 0;									// ݋֎~
}

void make_dot_patarn() {								// hbgp^[쐬
	unsigned short r;
	
	make_dot_doing = 1;									// ݋֎~tO
	if (disp_ch == disp_len)							// 1.2oCgڂINDEX
		disp_next = 0;
	else
		disp_next = disp_ch + 1;
	for (r = 0; r < MAX_ROW; r++) {
		ee_adr = dgt[disp_ch] * EEP_BLOCK + r;			// 1rsڂ̃AhX
		ee_dat = eeprom_read(ee_adr);					// EEPROMǂ
		ee_dat = (ee_dat << chr_sft);					// ɋl߂
		dat_up = (ee_dat << disp_bt);					// XN[Vtg
		if (disp_len > 0) {								// 2ڂ
			ee_adr = dgt[disp_next] * EEP_BLOCK + r;
			ee_dat = eeprom_read(ee_adr);
			ee_dat = (ee_dat << chr_sft);
			dat_dn = ee_dat >> ((chr_width - disp_bt));
		} else {
			dat_dn = 0;
		}
		rom_dat[r] = (unsigned char) dat_up | dat_dn;	// 
	}
	if (button_mode == MODE_CLOCK) {					// CLOCK̓XN[
		disp_bt++;										// XN[Ehbg
		if (disp_bt == chr_width) {						// PXN[
			disp_bt = 0;								// XN[Ehbg=0
			disp_ch++;									// 擪͎̕
		}
		if (disp_ch > disp_len) {						// SXN[
			disp_ch = 0;								// ŏ
		}
	}
	make_dot_doing = 0;									// ݋֎~
}

static interrupt int_server(void) {						// ݃[`
	char r;

	if (TMR1IF) {										// ^C}[P
		t_save += 0x10000;								// 1TTMR1Abv
		if (t_save > SEC_COUNT) {						// 11.776MHz̏ꍇ1b
			ss++;										// bJEg
			t_save -= SEC_COUNT;						// 1bJE^
			if (ss >= 60){								// JEg
				mm++;
				ss=0;
			}
			if (mm >= 60) {								// JEg
				hh++;
				mm=0;
			}
			if (hh >= 24)
				hh = 0;
			if(!make_st_doing)							// 쐬Ăяo
				make_string();
		}

		watch++;										// 21
		if (watch % 2 == 0) {							// hbgp^[쐬Ăяo
			if (!make_dot_doing)
				make_dot_patarn();
		}	
		TMR1IF = 0;										// ݃tONA
	}
	if (T0IF) {											// ^C}O
		if (!slp_on) {
			if (!make_dot_doing) {
				for ( r = 0; r < 8; r++) {				// 0-8sڂ̃hbgp^[\
					PORTB = 0;
					PORTA = (PORTA & 0b11111000) | r;
					PORTB = rom_dat[r];
					__delay_us(10);
				}
			}
		}
		PORTB = 0;
		T0IF = 0;
	}
}

void button_proc() {									// {^
	if (!SWT_MODE) {									// MODE {^
		__delay_ms(20);									// `^Oh~
		if (!SWT_MODE) {
			watch = 0;
			if (slp_on) {								// SLEEP 
				slp_on = 0;
			} else {
				adj_on = 0;
				button_mode++;
				make_string();
				if (button_mode > MODE_SLEEP)
					button_mode = MODE_CLOCK;
			}
		}
	}
	if (!SWT_1) {										// SWT_1 {^(ENTER)
		__delay_ms(20);
		if (!SWT_1) {
			watch = 0;
			switch (button_mode) {
				case MODE_SECOND:						// b[h̎
					ss = 0;								// bNA
					t_save = 0;
					break;
				case MODE_ADJHH:						// Zbg[h̎
				case MODE_ADJMM:
					adj_on = !adj_on;
					break;
				case MODE_SLEEP:						// X[v[ĥƂ
					slp_mode = !slp_mode;
					break;
			}
			make_string();
		}
	}
	if (!SWT_2) {										// SWT_2 {^(SET++)
		__delay_ms(20);
		if (!SWT_2) {
			watch = 0;
			switch (button_mode) {
				case MODE_SECOND:
					t_save = 0;
					ss = 0;
					break;
				case MODE_ADJHH:
					if (adj_on)   hh++;					// i߂
					if (hh >= 24) hh = 0;
					break;
				case MODE_ADJMM:
					if (adj_on)   mm++;					// i߂
					if (mm >= 60) mm = 0;
					break;
			}
			make_string();
		}
	}
}

void main()
{
	OPTION 	= 0b00000000;					// ^C} T0CS(CLOCK=in), T0SE(Out=N/A)
											//		PSA(TMR0)=0, SCALSE=1:2
	TRISB	= 0x00000000;								// o͐ݒ
	CMCON	= 0b00000111;								// Rp[^gp
	PORTA 	= 0;										// PORTANA
	TRISA	= 0b11111000;								// o͐ݒ IN=4-7

	button_mode = MODE_CLOCK;							// ϐ
	adj_on = 0;
	ss = mm = hh = 0;
	disp_ch = 0;
	disp_bt = 0;
	slp_on  = 0;
	slp_mode = 0;
	make_dot_doing = 0;
	make_st_doing = 0;
	watch = 0;
	t_save = 0;
	make_string();										// 񏉊
	make_dot_patarn();									// hbgp^[

	T1CKPS1 = 1;
	T1CKPS0 = 0;										// TMR1 PRESCALE=1:4
	TMR1H = 0x00;										// TMR1NA
	TMR1L = 0x00;
	TMR0  = 0;											// TMR0NA
	T0IE = 1;											// TMR0
	TMR1IE = 1;											// TMR1
	TMR1ON = 1;											// TMR1I
	GIE = 1;											// S̊ON

	while(1){					//JԂ[v
		button_proc();
		if (slp_mode) {
			if (watch > WATCH_SLP) {
				slp_on = 1;
				__delay_ms(50);
			}
		}
	}
}

__EEPROM_DATA(14,17,17,17,17,17,17,14);	//0
__EEPROM_DATA(4,12,4,4,4,4,4,14);		//1
__EEPROM_DATA(14,17,17,2,4,8,16,31);	//2
__EEPROM_DATA(14,17,1,1,14,1,17,14);	//3
__EEPROM_DATA(2,6,10,10,18,31,2,2);		//4
__EEPROM_DATA(31,16,16,30,1,1,1,30);	//5
__EEPROM_DATA(14,16,16,30,17,17,17,14);	//6
__EEPROM_DATA(31,1,1,2,4,4,4,4);		//7
__EEPROM_DATA(14,17,17,14,17,17,17,14);	//8
__EEPROM_DATA(14,17,17,17,15,1,1,14);	//9
__EEPROM_DATA(0,4,10,4,0,4,10,4); 		// : (10)
__EEPROM_DATA(14,17,31,17,0,27,21,17);	//AM (11)
__EEPROM_DATA(30,17,30,16,0,27,21,17);	//PM (12)
__EEPROM_DATA(0,0,0,0,0,0,0,0);			//BLK (13)
__EEPROM_DATA(0,6,9,9,9,9,9,6);			//0 (14)
__EEPROM_DATA(0,2,6,2,2,2,2,7);			//1
__EEPROM_DATA(0,6,9,1,2,4,8,15);		//2
__EEPROM_DATA(0,6,9,1,2,1,9,6);			//3
__EEPROM_DATA(0,2,6,10,10,15,2,2);		//4
__EEPROM_DATA(0,15,8,8,14,1,1,14);		//5
__EEPROM_DATA(0,6,8,8,14,9,9,6);		//6
__EEPROM_DATA(0,15,9,1,2,2,2,2);		//7
__EEPROM_DATA(0,6,9,9,6,9,9,6);			//8
__EEPROM_DATA(0,6,9,9,7,1,1,6);			//9
__EEPROM_DATA(228, 191, 164, 255, 162, 191, 226, 10); 	// (24)
__EEPROM_DATA(24, 36, 66, 129, 126, 18, 18, 38); 		// (25)
__EEPROM_DATA(224, 64, 64, 229, 2, 229, 32, 224); 		//GRoff(26)
__EEPROM_DATA(224, 64, 70, 233, 9, 230, 32, 224); 		//GRon (27)
__EEPROM_DATA(4, 136, 240, 167, 32, 72, 18, 62); 		//Game (28)
